SystemOrganization addCategory: #SWA014!

Object subclass: #SWA014Game
	instanceVariableNames: 'world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game methodsFor: 'deleting' stamp: 'M.V. 11/25/2016 00:30'!
destroyAllEntities
	self flag: 'TODO: delete this method; this method only helps us controlling all objects, we do not need anymore for tests'.
	
	self swaworld listOfEnemies do: 
	[:x| x delete].
	self swaworld listOfEnemies: Set new.

	self swaworld player delete.
	self swaworld player: nil.
	
	self swaworld delete.
	self swaworld: nil.! !

!SWA014Game methodsFor: 'game events' stamp: 'M.V. 11/24/2016 21:50'!
gameOver
	self destroyAllEntities.! !

!SWA014Game methodsFor: 'initialization' stamp: 'M.V. 11/24/2016 21:48'!
initialize
	super initialize.
	self swaworld: SWA014World new.
	self swaworld game: self.! !

!SWA014Game methodsFor: 'spawning' stamp: 'M.V. 11/25/2016 12:35'!
spawnEnemy
"spawns SWA014Enemys up to the specified number"
|enemy random r1 r2 r3 MAXSIZE NUMBER_OF_ENEMIES|
MAXSIZE := 75.
NUMBER_OF_ENEMIES := 10.

1 to: NUMBER_OF_ENEMIES  do:
[:x|	
	enemy := SWA014Enemy new openInWorld.
	random := Random new.
	r1 := random nextInt: self swaworld width.
	r2 := random nextInt: self swaworld height.
	r3 := random nextInt: MAXSIZE.
	enemy position: (r1@r2).
	enemy size: r3.	
	enemy swaworld: self swaworld.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.
].! !

!SWA014Game methodsFor: 'spawning' stamp: 'M.V. 11/25/2016 12:35'!
spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new openInWorld.
	newPlayer color: Color red.
	newPlayer size: 50.
	newPlayer position: self swaworld center.
	newPlayer swaworld: self swaworld.		
	self swaworld player: newPlayer.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'spawning' stamp: 'M.V. 11/18/2016 13:29'!
start
	self spawnPlayer.
	self spawnEnemy.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld: x
	world := x.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'size speed id direction world currentStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'M.V. 11/25/2016 01:19'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target center.
	
	target size >= self size
	ifTrue:
	 [
		self direction: (0@0) - self direction.
	].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'M.V. 11/25/2016 12:41'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance BIGNUMBER|
	
	BIGNUMBER := SmallInteger maxVal.
	smallestDistance := BIGNUMBER.
	nearestEnemyobject := self.
	
	allEnemies := Set new.
	allEnemies := self swaworld listOfEnemies copy.
	allEnemies add: self swaworld player.
	
	allEnemies do: 
	[:enemy| 
	currentDistance := self distanceTo: enemy center.
	((currentDistance  < smallestDistance) and: (currentDistance ~~ 0))
	ifTrue: [smallestDistance := currentDistance.
			nearestEnemyobject := enemy.]
	].

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'M.V. 11/25/2016 01:19'!
step
	self currentStep > self stepNumber
	ifTrue:
	[
		self calculateMovement: self nearestEnemy.
		self moveAutomatically.
		self currentStep: 0.
	] 
	ifFalse:
	[
		self currentStep: self currentStep + 1.
	].
	
	super step.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/25/2016 01:13'!
calculateMovement: target
	|directionVector deltaX deltaY distance|
		
	deltaX := (target x - self center x).
	deltaY := (target y - self center y).
	
	distance := self distanceTo: target.
	distance == 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	
	directionVector := ((deltaX/distance)@(deltaY/distance)).
	
	self direction: directionVector.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'M.V. 11/25/2016 12:31'!
checkForCollisions
	|radius listOfLivingThings|
	
	radius := self size/2.	
	listOfLivingThings := Set new.
	listOfLivingThings := self swaworld listOfEnemies copy.
	listOfLivingThings add: self swaworld player.
	
	listOfLivingThings do:
	[	
		:enemy|
		(enemy ~~ self) ifTrue: 
		[
			(enemy size < self size) ifTrue: 
			[
				((self distanceTo: enemy center) < radius) ifTrue: 
				[
					self eat: enemy.
				]
			]
		]
	]! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'M.V. 11/25/2016 01:14'!
distanceTo: enemy
	^(((enemy x - self center x) raisedTo: 2)+
	((enemy y - self center y) raisedTo: 2)) sqrt. "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'M.V. 11/24/2016 21:50'!
eat: prey
	self size: 2* (((self size / 2) raisedTo: 2) + ((prey size / 2) raisedTo: 2)) sqrt.

	self swaworld listOfEnemies: 
		(self swaworld listOfEnemies reject: [:enemy| enemy == prey]).
	(prey ~~ self swaworld player) 
	ifTrue: 
	[
		prey delete.
	]
	ifFalse: 
	[
		self swaworld game gameOver.
	].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'M.V. 11/25/2016 00:37'!
initialize
	super initialize.
	self currentStep: 0.
	self speed: 60.
	self direction: (0@0).! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/25/2016 00:39'!
moveAutomatically
	self center: self center + (2 * (self direction)).! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/12/2016 13:26'!
refreshSize
	self extent: (self size)@(self size).
	
	! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/4/2016 12:34'!
size 
	^size.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/24/2016 15:00'!
size: x
	|MAX_ALLOWED_SIZE MIN_ALLOWED_SIZE|
	
	MAX_ALLOWED_SIZE := 1000.
	MIN_ALLOWED_SIZE := 10.
	
	x < MAX_ALLOWED_SIZE
	ifTrue: 
	[
		x > MIN_ALLOWED_SIZE
		ifTrue: 
		[
			size := x.
		]
		ifFalse: 
		[
			size := MIN_ALLOWED_SIZE.
		].		
	]
	ifFalse:
	[
		size := MAX_ALLOWED_SIZE.
	] .
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/24/2016 15:02'!
speed: x
	|MAX_ALLOWED_SPEED MIN_ALLOWED_SPEED|
	
	MAX_ALLOWED_SPEED := 1000.
	MIN_ALLOWED_SPEED := 1.
	
	x < MAX_ALLOWED_SPEED
	ifTrue: 
	[
		x> MIN_ALLOWED_SPEED
		ifTrue: 
		[
			 speed := x.
		]
	 	ifFalse:
		[
			speed := MIN_ALLOWED_SPEED.
		].
	]
	ifFalse:
	[
		speed := MAX_ALLOWED_SPEED.
	] .
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/18/2016 14:19'!
step
	self checkForCollisions.
	self refreshSize.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/24/2016 22:14'!
stepNumber
	"This is used to keep the stepTime up to date"
	
	self speed ~= 0
	ifTrue:
	[
		^10 * (self size sqrt)  / self speed.	
	]
	ifFalse: 
	[
		^SmallInteger maxVal.	"Stops stepping"
	].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/18/2016 14:38'!
stepTime
	^1! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld: x
	world := x.! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'movement' stamp: 'M.V. 11/25/2016 12:35'!
moveAutomatically
	self swaworld center: self swaworld center - self direction.
	"self center: self center + self direction."! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'M.V. 11/25/2016 11:16'!
step
	super step.
	self calculateMovement: World activeHand center.
	self moveAutomatically.! !

CircleMorph subclass: #SWA014World
	instanceVariableNames: 'size listOfEnemies player game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 14:26'!
height
	^World bounds corner y.! !

!SWA014World methodsFor: 'initialization' stamp: 'M.V. 11/25/2016 11:43'!
initialize
	|aForm|
	super initialize.
	self listOfEnemies: Set new.
	self player: nil.
	self size: 3000.
	self extent: (self size @ self size).
	self center: ((self width / 2)@(self height / 2)).
	self openInWorld.
	self color: Color transparent.
	
	"aForm := ImageReadWriter formFromFileNamed: 'Chrysanthemum.jpg'.
	ImageMorph new newForm: aForm; openInWorld."
! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies: anObject
	listOfEnemies := anObject! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/11/2016 16:12'!
player
	^player.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/11/2016 16:12'!
player: x
	player := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 13:07'!
size
	^size! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 12:47'!
size: anObject
	size := anObject! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/11/2016 12:01'!
width
	^ World bounds corner x.! !
